<?php
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

enum InvalidMethodEnum {
    // PHP Fatal error:  Enum InvalidMethodEnum must implement 3 abstract private methods (InvalidMethodEnum::abstractImplicitPublicEnumMethod, InvalidMethodEnum::abstractPublicEnumMethod, InvalidMethodEnum::abstractProtectedEnumMethod)
    abstract function abstractImplicitPublicEnumMethod(); // method error enum

    abstract public function abstractPublicEnumMethod(); // method error enum

    abstract protected function abstractProtectedEnumMethod(); // method error enum

    abstract private function abstractPrivateEnumMethod(): void; // method error enum

    // PHP Fatal error:  Abstract function cannot contain body
    abstract function abstractImplicitPublicBodyEnumMethod(): void {} // method error enum
//  function abstractEnumMethod(): void {} // method error enum

    abstract public function abstractPublicBodyEnumMethod(): void {} // method error enum
//  public function abstractPublicEnumMethod2(): void {} // method error enum

    abstract protected function abstractProtectedBodyEnumMethod(): void {} // method error enum
//  protected function abstractProtectedEnumMethod2(): void {} // method error enum

    abstract private function abstractPrivateBodyEnumMethod(): void {} // method error enum
//  private function abstractPrivateEnumMethod(): void {} // method error enum
}
